import * as React from "react";
import { IModel, IModelData, IQueryBuilder, IQueryManager, IQueryParams } from "redux-data-service";
import { Omit } from "redux-data-service/dist/Omit";
import { IWithDelayedHandlers } from "../WithDelayedHandlers";
export interface IInfiniteScrollProps<T extends IModelData> extends IWithDelayedHandlers {
    modelName: string;
    query: IQueryParams | IQueryBuilder;
    containerComponent: React.ComponentType<{
        onScroll: React.UIEventHandler;
    } & any>;
    modelComponent: React.ComponentType<{
        model: T;
    } & any>;
    modelComponentProps?: any;
    disableVirtualScrolling?: boolean;
    contentPlaceHolderComponent?: React.ComponentType<{
        height: number | string;
    }>;
    contentPlaceHolderComponentProps?: any;
    [key: string]: any;
}
export interface IInfiniteScrollStateProps<T extends IModelData> {
    currentItems: T[];
    currentPage: number;
    currentPageStartMarkerRef: React.RefObject<any>;
    currentPageEndMarkerRef: React.RefObject<any>;
    hasNextPage: boolean;
    hasPreviousPage: boolean;
    lastScrollTop: number;
    nextPage: number;
    nextPageEndMarkerRef: React.RefObject<any>;
    nextPageQuery: IQueryBuilder;
    nextPageStartMarkerRef: React.RefObject<any>;
    nextPlaceHolderHeight: number;
    pageHeightMap: {
        [key: string]: number;
    };
    previousPage: number;
    previousPageEndMarkerRef: React.RefObject<any>;
    previousPageQuery: IQueryBuilder;
    previousPageStartMarkerRef: React.RefObject<any>;
    previousPlaceHolderHeight: number;
    query: IQueryBuilder;
    totalPages: number;
}
export interface IInfiniteScrollInternalProps<T extends IModel<IModelData>> extends Omit<IInfiniteScrollProps<T>, "query">, Omit<IInfiniteScrollStateProps<T>, "query"> {
    query: IQueryManager<T>;
    estimatedPageHeight: number;
}
export declare const InfiniteScroll: React.ComponentClass<IInfiniteScrollProps<any>>;
